diff --git a/sys/dev/virtual/vmware/shared/vm_basic_asm.h b/sys/dev/virtual/vmware/shared/vm_basic_asm.h
index 3886f07..1e287bb 100644
--- a/sys/dev/virtual/vmware/shared/vm_basic_asm.h
+++ b/sys/dev/virtual/vmware/shared/vm_basic_asm.h
@@ -109,6 +109,9 @@ void _mm_mfence(void);
 void _mm_lfence(void);
 #pragma intrinsic(_mm_mfence, _mm_lfence)
 
+unsigned int __getcallerseflags(void);
+#pragma intrinsic(__getcallerseflags)
+
 #ifdef VM_X86_64
 /*
  * intrinsic functions only supported by x86-64 windows as of 2k3sp1
@@ -128,9 +131,11 @@ unsigned char  _BitScanForward(unsigned long *, unsigned long);
 unsigned char  _BitScanReverse(unsigned long *, unsigned long);
 #pragma intrinsic(_BitScanForward, _BitScanReverse)
 
+unsigned char  _bittest(const long *, long);
 unsigned char  _bittestandset(long *, long);
 unsigned char  _bittestandreset(long *, long);
-#pragma intrinsic(_bittestandset, _bittestandreset)
+unsigned char  _bittestandcomplement(long *, long);
+#pragma intrinsic(_bittest, _bittestandset, _bittestandreset, _bittestandcomplement)
 #ifdef VM_X86_64
 unsigned char  _bittestandset64(__int64 *, __int64);
 unsigned char  _bittestandreset64(__int64 *, __int64);
@@ -197,6 +202,14 @@ __GCC_IN(l, uint32, IN32)
 #define GET_CURRENT_EIP(_eip) \
       __asm__ __volatile("call 0\n\tpopl %0" : "=r" (_eip): );
 
+static INLINE unsigned int
+GetCallerEFlags(void)
+{
+   unsigned long flags;
+   asm volatile("pushf; pop %0" : "=r"(flags));
+   return flags;
+}
+
 #endif // x86*
 
 #elif defined(_MSC_VER) // } {
@@ -243,6 +256,12 @@ OUT32(uint16 port, uint32 value)
 } while (0)
 #endif // VM_X86_64
 
+static INLINE unsigned int
+GetCallerEFlags(void)
+{
+   return __getcallerseflags();
+}
+
 #else // } {
 #error
 #endif // }
@@ -355,36 +374,115 @@ mssb64_0(const uint64 value)
 #define USE_ARCH_X86_CUSTOM
 #endif
 
+/* **********************************************************
+ *  GCC's intrinsics for the lssb and mssb family produce sub-optimal code,
+ *  so we use inline assembly to improve matters.  However, GCC cannot
+ *  propagate constants through inline assembly, so we help GCC out by
+ *  allowing it to use its intrinsics for compile-time constant values.
+ *  Some day, GCC will make better code and these can collapse to intrinsics.
+ *
+ *  For example, in Decoder_AddressSize, inlined into VVT_GetVTInstrInfo:
+ *  __builtin_ffs(a) compiles to:
+ *  mov   $0xffffffff, %esi
+ *  bsf   %eax, %eax
+ *  cmovz %esi, %eax
+ *  sub   $0x1, %eax
+ *  and   $0x7, %eax
+ *
+ *  While the code below compiles to:
+ *  bsf   %eax, %eax
+ *  sub   $0x1, %eax
+ *
+ *  Ideally, GCC should have recognized non-zero input in the first case.
+ *  Other instances of the intrinsic produce code like
+ *  sub $1, %eax; add $1, %eax; clts
+ * **********************************************************
+ */
+
+#if __GNUC__ < 4
+#define FEWER_BUILTINS
+#endif
+
 static INLINE int
 lssb32_0(uint32 value)
 {
 #if defined(USE_ARCH_X86_CUSTOM)
+   if (!__builtin_constant_p(value)) {
    if (UNLIKELY(value == 0)) {
       return -1;
    } else {
       int pos;
-      __asm__ __volatile__("bsfl %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
+         __asm__ ("bsfl %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
       return pos;
    }
-#else
-   return __builtin_ffs(value) - 1;
+   }
 #endif
+   return __builtin_ffs(value) - 1;
 }
 
+#ifndef FEWER_BUILTINS
 static INLINE int
 mssb32_0(uint32 value)
 {
+   /*
+    * We must keep the UNLIKELY(...) outside the #if defined ...
+    * because __builtin_clz(0) is undefined according to gcc's
+    * documentation.
+    */
    if (UNLIKELY(value == 0)) {
       return -1;
    } else {
       int pos;
+#if defined(USE_ARCH_X86_CUSTOM)
+      if (!__builtin_constant_p(value)) {
+         __asm__ ("bsrl %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
+         return pos;
+      }
+#endif
+      pos = 32 - __builtin_clz(value) - 1;
+      return pos;
+   }
+}
 
+static INLINE int
+lssb64_0(const uint64 value)
+{
 #if defined(USE_ARCH_X86_CUSTOM)
-      __asm__ __volatile__("bsrl %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
+   if (!__builtin_constant_p(value)) {
+      if (UNLIKELY(value == 0)) {
+         return -1;
+      } else {
+         intptr_t pos;
+   #if defined(VM_X86_64)
+         __asm__ ("bsf %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
 #else
-      pos = 32 - __builtin_clz(value) - 1;
+         /* The coding was chosen to minimize conditionals and operations */
+         pos = lssb32_0((uint32) value);
+         if (pos == -1) {
+            pos = lssb32_0((uint32) (value >> 32));
+            if (pos != -1) {
+               return pos + 32;
+            }
+         }
+   #endif
+         return pos;
+      }
+   }
 #endif
+   return __builtin_ffsll(value) - 1;
+}
+#endif /* !FEWER_BUILTINS */
 
+#if defined(FEWER_BUILTINS)
+/* GCC 3.3.x does not like __bulitin_clz or __builtin_ffsll. */
+static INLINE int
+mssb32_0(uint32 value)
+{
+   if (UNLIKELY(value == 0)) {
+      return -1;
+   } else {
+      int pos;
+      __asm__ __volatile__("bsrl %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
       return pos;
    }
 }
@@ -392,7 +490,6 @@ mssb32_0(uint32 value)
 static INLINE int
 lssb64_0(const uint64 value)
 {
-#if defined(USE_ARCH_X86_CUSTOM)
    if (UNLIKELY(value == 0)) {
       return -1;
    } else {
@@ -409,14 +506,12 @@ lssb64_0(const uint64 value)
             return pos + 32;
          }
       }
-#endif
-
+   #endif /* VM_X86_64 */
       return pos;
    }
-#else
-   return __builtin_ffsll(value) - 1;
-#endif
 }
+#endif /* FEWER_BUILTINS */
+
 
 static INLINE int
 mssb64_0(const uint64 value)
@@ -428,7 +523,7 @@ mssb64_0(const uint64 value)
 
 #if defined(USE_ARCH_X86_CUSTOM)
 #if defined(VM_X86_64)
-      __asm__ __volatile__("bsr %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
+      __asm__ ("bsr %1, %0\n" : "=r" (pos) : "rm" (value) : "cc");
 #else
       /* The coding was chosen to minimize conditionals and operations */
       if (value > 0xFFFFFFFFULL) {
@@ -525,8 +620,8 @@ uint16set(void *dst, uint16 val, size_t count)
         );
    return dst;
 #else
-   int dummy0;
-   int dummy1;
+   size_t dummy0;
+   void *dummy1;
 
    __asm__ __volatile__("\t"
                         "cld"            "\n\t"
@@ -555,8 +650,8 @@ uint32set(void *dst, uint32 val, size_t count)
         );
    return dst;
 #else
-   int dummy0;
-   int dummy1;
+   size_t dummy0;
+   void *dummy1;
 
    __asm__ __volatile__("\t"
                         "cld"            "\n\t"
@@ -662,7 +757,8 @@ Bswap16(uint16 v)
 static INLINE uint32
 Bswap32(uint32 v) // IN
 {
-#if defined(__GNUC__) && (defined(__i386__) || defined(__x86_64__)) || defined(__arm__) // {
+#if defined(__GNUC__) && (defined(__i386__) || defined(__x86_64__)) || \
+   (defined(__arm__) && !defined(__ANDROID__))  // {
 #ifdef __arm__
     __asm__("rev %0, %0" : "+r"(v));
     return v;
@@ -720,6 +816,47 @@ Bswap64(uint64 v) // IN
 
 
 /*
+ *----------------------------------------------------------------------
+ *
+ * COMPILER_FORCED_LOAD_AND_MEM_BARRIER --
+ *
+ *        This macro prevents the compiler from re-ordering memory references
+ *        across the barrier. In addition it emits a forced load from the given
+ *        memory reference. The memory reference has to be either 1, 2, 4 or 8
+ *        bytes wide.
+ *        The forced load of a memory reference can be used exploit details of a
+ *        given CPUs memory model. For example x86 CPUs won't reorder stores to
+ *        a memory location x with loads from a memory location x.
+ *        NOTE: It does not generate any fencing instruction, so the CPU is free
+ *              to reorder instructions according to its memory model.
+ *
+ * Results:
+ *        None
+ *
+ * Side Effects:
+ *        None.
+ *
+ *----------------------------------------------------------------------
+ */
+
+#ifdef VM_X86_64
+#ifdef __GNUC__
+
+#define COMPILER_FORCED_LOAD_AND_MEM_BARRIER(_memory_reference)               \
+   do {                                                                       \
+      typeof(_memory_reference) _dummy;                                       \
+                                                                              \
+      asm volatile("mov %1, %0\n\t"                                           \
+                   : "=r" (_dummy) /* Let compiler choose reg for _dummy */   \
+                   : "m" (_memory_reference)                                  \
+                   : "memory");                                               \
+   } while(0)
+
+#endif /* __GNUC__ */
+#endif /* VM_X86_64 */
+
+
+/*
  * PAUSE is a P4 instruction that improves spinlock power+performance;
  * on non-P4 IA32 systems, the encoding is interpreted as a REPZ-NOP.
  * Use volatile to avoid NOP removal.
@@ -866,18 +1003,22 @@ RDTSC_BARRIER(void)
  *-----------------------------------------------------------------------------
  */
 
+#ifdef __arm__
+#define DEBUGBREAK() __asm__("bkpt")
+#else
 #ifdef _MSC_VER
 #define DEBUGBREAK()   __debugbreak()
 #else
 #define DEBUGBREAK()   __asm__ (" int $3 ")
 #endif
+#endif // __arm__
 #endif // defined(__i386__) || defined(__x86_64__) || defined(__arm__)
 
 
 /*
  *-----------------------------------------------------------------------------
  *
- * {Clear,Set}Bit{32,64} --
+ * {Clear,Set,Test}Bit{32,64} --
  *
  *    Sets or clears a specified single bit in the provided variable.
  *    The index input value specifies which bit to modify and is 0-based.
@@ -891,13 +1032,13 @@ RDTSC_BARRIER(void)
  */
 
 static INLINE void
-SetBit32(uint32 *var, unsigned index)
+SetBit32(uint32 *var, uint32 index)
 {
 #ifdef __GNUC__
    __asm__ (
       "bts %1, %0"
       : "+mr" (*var)
-      : "ri" (index)
+      : "rI" (index)
       : "cc"
    );
 #elif defined(_MSC_VER)
@@ -906,13 +1047,13 @@ SetBit32(uint32 *var, unsigned index)
 }
 
 static INLINE void
-ClearBit32(uint32 *var, unsigned index)
+ClearBit32(uint32 *var, uint32 index)
 {
 #ifdef __GNUC__
    __asm__ (
       "btr %1, %0"
       : "+mr" (*var)
-      : "ri" (index)
+      : "rI" (index)
       : "cc"
    );
 #elif defined(_MSC_VER)
@@ -922,13 +1063,13 @@ ClearBit32(uint32 *var, unsigned index)
 
 #if defined(VM_X86_64)
 static INLINE void
-SetBit64(uint64 *var, unsigned index)
+SetBit64(uint64 *var, uint64 index)
 {
 #ifdef __GNUC__
    __asm__ (
       "bts %1, %0"
       : "+mr" (*var)
-      : "ri" (index)
+      : "rJ" (index)
       : "cc"
    );
 #elif defined _MSC_VER
@@ -937,13 +1078,13 @@ SetBit64(uint64 *var, unsigned index)
 }
 
 static INLINE void
-ClearBit64(uint64 *var, unsigned index)
+ClearBit64(uint64 *var, uint64 index)
 {
 #ifdef __GNUC__
    __asm__ (
-      "btr %1, %0"
+      "btrq %1, %0"
       : "+mr" (*var)
-      : "ri" (index)
+      : "rJ" (index)
       : "cc"
    );
 #elif defined _MSC_VER
@@ -952,6 +1093,136 @@ ClearBit64(uint64 *var, unsigned index)
 }
 #endif /* VM_X86_64 */
 
+static INLINE Bool
+TestBit32(const uint32 *var, uint32 index)
+{
+#ifdef __GNUC__
+   Bool bit;
+   __asm__ (
+      "bt %[index], %[var] \n"
+      "setc %[bit]"
+      : [bit] "=qQm" (bit)
+      : [index] "rI" (index), [var] "r" (*var)
+      : "cc"
+   );
+   return bit;
+#else
+   return (*var & (1 << index)) != 0;
+#endif
+}
+
+static INLINE Bool
+TestBit64(const uint64 *var, uint64 index)
+{
+#if defined __GNUC__ && defined VM_X86_64
+   Bool bit;
+   __asm__ (
+      "bt %[index], %[var] \n"
+      "setc %[bit]"
+      : [bit] "=qQm" (bit)
+      : [index] "rJ" (index), [var] "r" (*var)
+      : "cc"
+   );
+   return bit;
+#else
+   return (*var & (CONST64U(1) << index)) != 0;
+#endif
+}
+
+/*
+ *-----------------------------------------------------------------------------
+ *
+ * {Clear,Set,Complement,Test}BitVector --
+ *
+ *    Sets, clears, complements, or tests a specified single bit in the
+ *    provided array.  The index input value specifies which bit to modify
+ *    and is 0-based.  Bit number can be +-2Gb (+-128MB) relative from 'var'
+ *    variable.
+ *
+ *    All functions return value of the bit before modification was performed.
+ *
+ *-----------------------------------------------------------------------------
+ */
+
+static INLINE Bool
+SetBitVector(void *var, int32 index)
+{
+#ifdef __GNUC__
+   Bool bit;
+   __asm__ (
+      "bts %2, %1;"
+      "setc %0"
+      : "=qQm" (bit), "+m" (*(volatile uint32 *)var)
+      : "rI" (index)
+      : "memory", "cc"
+   );
+   return bit;
+#elif defined(_MSC_VER)
+   return _bittestandset((long *)var, index) != 0;
+#else
+#error No compiler defined for SetBitVector
+#endif
+}
+
+static INLINE Bool
+ClearBitVector(void *var, int32 index)
+{
+#ifdef __GNUC__
+   Bool bit;
+   __asm__ (
+      "btr %2, %1;"
+      "setc %0"
+      : "=qQm" (bit), "+m" (*(volatile uint32 *)var)
+      : "rI" (index)
+      : "cc"
+   );
+   return bit;
+#elif defined(_MSC_VER)
+   return _bittestandreset((long *)var, index) != 0;
+#else
+#error No compiler defined for ClearBitVector
+#endif
+}
+
+static INLINE Bool
+ComplementBitVector(void *var, int32 index)
+{
+#ifdef __GNUC__
+   Bool bit;
+   __asm__ (
+      "btc %2, %1;"
+      "setc %0"
+      : "=qQm" (bit), "+m" (*(volatile uint32 *)var)
+      : "rI" (index)
+      : "cc"
+   );
+   return bit;
+#elif defined(_MSC_VER)
+   return _bittestandcomplement((long *)var, index) != 0;
+#else
+#error No compiler defined for ComplementBitVector
+#endif
+}
+
+static INLINE Bool
+TestBitVector(const void *var, int32 index)
+{
+#ifdef __GNUC__
+   Bool bit;
+   __asm__ (
+      "bt %2, %1;"
+      "setc %0"
+      : "=qQm" (bit)
+      : "m" (*(const uint32 *)var), "rI" (index)
+      : "cc"
+   );
+   return bit;
+#elif defined _MSC_VER
+   return _bittest((long *)var, index) != 0;
+#else
+#error No compiler defined for TestBitVector
+#endif
+}
 
 /*
  *-----------------------------------------------------------------------------
@@ -1021,7 +1292,21 @@ RoundUpPow2C32(uint32 value)
 static INLINE uint32
 RoundUpPow2Asm32(uint32 value)
 {
+#ifdef __arm__
+   uint32 out = 1;
+   // Note: None Thumb only!
+   //       The value of the argument "value"
+   //       will be affected!
+   __asm__("sub %[in], %[in], #1;"         // r1 = value - 1 . if value == 0 then r1 = 0xFFFFFFFF
+           "clz %[in], %[in];"             // r1 = log2(value - 1) if value != 1
+                                           // if value == 0 then r1 = 0
+                                           // if value == 1 then r1 = 32
+           "mov %[out], %[out], ror %[in]" // out = 2^(32 - r1)
+                                           // if out == 2^32 then out = 1 as it is right rotate
+       : [in]"+r"(value),[out]"+r"(out));
+#else
    uint32 out = 2;
+
    __asm__("lea -1(%[in]), %%ecx;"      // ecx = value - 1.  Preserve original.
            "bsr %%ecx, %%ecx;"          // ecx = log2(value - 1) if value != 1
                                         // if value == 0, then ecx = 31
@@ -1032,6 +1317,7 @@ RoundUpPow2Asm32(uint32 value)
                                         // zf is always unmodified
            "cmovz %[in], %[out]"        // if value == 1 (zf == 1), write 1 to out.
        : [out]"+r"(out) : [in]"r"(value) : "%ecx", "cc");
+#endif
    return out;
 }
 #endif // __GNUC__
diff --git a/sys/dev/virtual/vmware/shared/vm_basic_asm_x86.h b/sys/dev/virtual/vmware/shared/vm_basic_asm_x86.h
index e4849ab..28cc0b5 100644
--- a/sys/dev/virtual/vmware/shared/vm_basic_asm_x86.h
+++ b/sys/dev/virtual/vmware/shared/vm_basic_asm_x86.h
@@ -56,6 +56,24 @@
 #error "x86-64 not supported"
 #endif
 
+/*
+ * XTEST
+ *     Return TRUE if processor is in transaction region.
+ *
+ */
+#if defined(__GNUC__) && (defined(VMM) || defined(VMKERNEL) || defined(FROBOS))
+static INLINE Bool
+xtest(void)
+{
+   uint8 al;
+   __asm__ __volatile__(".byte 0x0f, 0x01, 0xd6    # xtest \n"
+                        "setnz %%al\n"
+                        : "=a"(al) : : "cc");
+   return al;
+}
+
+#endif /* __GNUC__ */
+
 
 /*
  * FXSAVE/FXRSTOR
diff --git a/sys/dev/virtual/vmware/shared/vm_basic_asm_x86_64.h b/sys/dev/virtual/vmware/shared/vm_basic_asm_x86_64.h
index b3e377e..7063896 100644
--- a/sys/dev/virtual/vmware/shared/vm_basic_asm_x86_64.h
+++ b/sys/dev/virtual/vmware/shared/vm_basic_asm_x86_64.h
@@ -285,6 +285,23 @@ XRSTOR_AMD_ES0(const void *load, uint64 mask)
 
 #endif /* __GNUC__ */
 
+/*
+ * XTEST
+ *     Return TRUE if processor is in transaction region.
+ *
+ */
+#if defined(__GNUC__) && (defined(VMM) || defined(VMKERNEL) || defined(FROBOS))
+static INLINE Bool
+xtest(void)
+{
+   uint8 al;
+   __asm__ __volatile__(".byte 0x0f, 0x01, 0xd6    # xtest \n"
+                        "setnz %%al\n"
+                        : "=a"(al) : : "cc"); 
+   return al;
+}
+
+#endif /* __GNUC__ */
 
 /*
  *-----------------------------------------------------------------------------
@@ -320,7 +337,7 @@ Mul64x6464(uint64 multiplicand,
    uint64 result, dummy;
 
    __asm__("mulq    %3      \n\t"
-           "shrdq   %1, %0  \n\t"
+           "shrdq   %b4, %1, %0  \n\t"
            : "=a" (result),
              "=d" (dummy)
            : "0"  (multiplier),
@@ -378,7 +395,7 @@ Muls64x64s64(int64 multiplicand, int64 multiplier, uint32 shift)
    int64 result, dummy;
 
    __asm__("imulq   %3      \n\t"
-       "shrdq   %1, %0  \n\t"
+       "shrdq   %b4, %1, %0  \n\t"
        : "=a" (result),
          "=d" (dummy)
        : "0"  (multiplier),
diff --git a/sys/dev/virtual/vmware/shared/vm_basic_defs.h b/sys/dev/virtual/vmware/shared/vm_basic_defs.h
index 8bab751..33d6bec 100644
--- a/sys/dev/virtual/vmware/shared/vm_basic_defs.h
+++ b/sys/dev/virtual/vmware/shared/vm_basic_defs.h
@@ -83,6 +83,9 @@
 #endif
 #endif // __APPLE__
 
+#define VMW_CONTAINER_OF(ptr, type, member) \
+   ((type *)((char *)(ptr) - offsetof(type, member)))
+
 #ifndef ARRAYSIZE
 #define ARRAYSIZE(a) (sizeof (a) / sizeof *(a))
 #endif
@@ -112,6 +115,9 @@ Max(int a, int b)
 }
 #endif
 
+#define VMW_CLAMP(x, min, max) \
+   ((x) < (min) ? (min) : ((x) > (max) ? (max) : (x)))
+
 #define ROUNDUP(x,y)		(((x) + (y) - 1) / (y) * (y))
 #define ROUNDDOWN(x,y)		((x) / (y) * (y))
 #define ROUNDUPBITS(x, bits)	(((uintptr_t) (x) + MASK(bits)) & ~MASK(bits))
@@ -130,6 +136,14 @@ Max(int a, int b)
 
 #define MASK(n)		((1 << (n)) - 1)	    /* make an n-bit mask */
 #define MASK64(n)	((CONST64U(1) << (n)) - 1)  /* make an n-bit mask */
+/*
+ * MASKRANGE64 makes a bit vector starting at bit lo and ending at bit hi.  No
+ * checking for lo < hi is done.
+ */
+#define MASKRANGE64(hi, lo)      (MASK64((hi) - (lo) + 1) << (lo))
+
+/* SIGNEXT64 sign extends a n-bit value to 64-bits. */
+#define SIGNEXT64(val, n)       (((int64)(val) << (64 - (n))) >> (64 - (n)))
 
 #define DWORD_ALIGN(x)          ((((x) + 3) >> 2) << 2)
 #define QWORD_ALIGN(x)          ((((x) + 7) >> 3) << 3)
@@ -169,8 +183,10 @@ Max(int a, int b)
  * Wide versions of string constants.
  */
 
+#ifndef WSTR
 #define WSTR_(X)     L ## X
 #define WSTR(X)      WSTR_(X)
+#endif
 
 
 /*
@@ -232,6 +248,14 @@ Max(int a, int b)
 #define PAGES_2_MBYTES(_npages) ((_npages) >> (20 - PAGE_SHIFT))
 #endif
 
+#ifndef GBYTES_2_PAGES
+#define GBYTES_2_PAGES(_nbytes) ((_nbytes) << (30 - PAGE_SHIFT))
+#endif
+
+#ifndef PAGES_2_GBYTES
+#define PAGES_2_GBYTES(_npages) ((_npages) >> (30 - PAGE_SHIFT))
+#endif
+
 #ifndef BYTES_2_MBYTES
 #define BYTES_2_MBYTES(_nbytes) ((_nbytes) >> 20)
 #endif
@@ -381,6 +405,8 @@ GetCallerFrameAddr(void)
 /* We do not have YIELD() as we do not need it yet... */
 #elif defined(_WIN32)
 #      define YIELD()		Sleep(0)
+#elif defined(VMKERNEL)
+/* We don't have a YIELD macro in the vmkernel */
 #else
 #      include <sched.h>        // For sched_yield.  Don't ask.  --Jeremy.
 #      define YIELD()		sched_yield()
@@ -409,10 +435,12 @@ sleep(unsigned int sec)
    Sleep(sec * 1000);
 }
 
-static INLINE void
+static INLINE int
 usleep(unsigned long usec)
 {
    Sleep(CEILING(usec, 1000));
+
+   return 0;
 }
 
 typedef int pid_t;
@@ -510,6 +538,9 @@ typedef int pid_t;
 #if __GLIBC_PREREQ(2, 5) && !defined GLIBC_VERSION_25
 #define GLIBC_VERSION_25
 #endif
+#if __GLIBC_PREREQ(2, 12) && !defined GLIBC_VERSION_212
+#define GLIBC_VERSION_212
+#endif
 #endif
 
 /*
@@ -549,6 +580,22 @@ typedef int pid_t;
 #define LOG_ONLY(x)
 #endif
 
+#ifdef VMX86_BETA
+#define vmx86_beta     1
+#define BETA_ONLY(x)   x
+#else
+#define vmx86_beta     0
+#define BETA_ONLY(x)
+#endif
+
+#ifdef VMX86_RELEASE
+#define vmx86_release   1
+#define RELEASE_ONLY(x) x
+#else
+#define vmx86_release   0
+#define RELEASE_ONLY(x) 
+#endif
+
 #ifdef VMX86_SERVER
 #define vmx86_server 1
 #define SERVER_ONLY(x) x
@@ -559,14 +606,6 @@ typedef int pid_t;
 #define HOSTED_ONLY(x) x
 #endif
 
-#ifdef VMX86_WGS
-#define vmx86_wgs 1
-#define WGS_ONLY(x) x
-#else
-#define vmx86_wgs 0
-#define WGS_ONLY(x)
-#endif
-
 #ifdef VMKERNEL
 #define vmkernel 1
 #define VMKERNEL_ONLY(x) x
@@ -578,14 +617,18 @@ typedef int pid_t;
 #ifdef _WIN32
 #define WIN32_ONLY(x) x
 #define POSIX_ONLY(x)
+#define vmx86_win32 1
 #else
 #define WIN32_ONLY(x)
 #define POSIX_ONLY(x) x
+#define vmx86_win32 0
 #endif
 
 #ifdef __linux__
+#define vmx86_linux 1
 #define LINUX_ONLY(x) x
 #else
+#define vmx86_linux 0
 #define LINUX_ONLY(x)
 #endif
 
@@ -635,7 +678,11 @@ typedef int pid_t;
 #ifdef _WIN32
 #ifndef USES_OLD_WINDDK
 #if defined(VMX86_LOG)
+#ifdef _WIN64
+#define WinDrvPrint(arg, ...) DbgPrintEx(DPFLTR_IHVDRIVER_ID, (ULONG)~0, arg, __VA_ARGS__)
+#else
 #define WinDrvPrint(arg, ...) DbgPrint(arg, __VA_ARGS__)
+#endif
 #define WinDrvEngPrint(arg, ...) EngDbgPrint(arg, __VA_ARGS__)
 #else
 #define WinDrvPrint(arg, ...)
@@ -657,4 +704,24 @@ typedef int pid_t;
 #define NONCLIENTMETRICSINFO_V1_SIZE CCSIZEOF_STRUCT(NONCLIENTMETRICS, \
                                                      lfMessageFont)
 
+/* This is not intended to be thread-safe. */
+#define DO_ONCE(code)                                                   \
+   do {                                                                 \
+      static Bool _doOnceDone = FALSE;                                  \
+      if (UNLIKELY(!_doOnceDone)) {                                     \
+         _doOnceDone = TRUE;                                            \
+         code;                                                          \
+      }                                                                 \
+   } while (0)
+
+/*
+ * Bug 827422 and 838523.
+ */
+
+#if defined __GNUC__ && __GNUC__ >= 4
+#define VISIBILITY_HIDDEN __attribute__((visibility("hidden")))
+#else
+#define VISIBILITY_HIDDEN /* nothing */
+#endif
+
 #endif // ifndef _VM_BASIC_DEFS_H_
diff --git a/sys/dev/virtual/vmware/shared/vm_basic_math.h b/sys/dev/virtual/vmware/shared/vm_basic_math.h
index 78d8d7f..0f12c22 100644
--- a/sys/dev/virtual/vmware/shared/vm_basic_math.h
+++ b/sys/dev/virtual/vmware/shared/vm_basic_math.h
@@ -75,4 +75,22 @@ ExponentialAvg(uint32 avg, uint32 value, uint32 gainNumer, uint32 gainDenom)
    return (term1 + term2) / gainDenom;
 }
 
+static INLINE Bool
+IsPowerOfTwo(uint32 x)
+{
+   /* Does not check for zero. Callers depend on this. */
+   return !(x & (x - 1));
+}
+
+static INLINE uint32
+GetPowerOfTwo(uint32 x)
+{
+   /* Returns next-greatest power-of-two. */
+   uint32 power2 = 1;
+   while (x > power2) {
+      power2 = power2 << 1;
+   }
+   return power2;
+}
+
 #endif // ifndef _VM_BASIC_MATH_H_
diff --git a/sys/dev/virtual/vmware/shared/vm_basic_types.h b/sys/dev/virtual/vmware/shared/vm_basic_types.h
index 06d9c83..8a24801 100644
--- a/sys/dev/virtual/vmware/shared/vm_basic_types.h
+++ b/sys/dev/virtual/vmware/shared/vm_basic_types.h
@@ -417,7 +417,6 @@ typedef uint8 *TCA;  /* Pointer into TC (usually). */
  */
 typedef uint8 Percent;
 #define AsPercent(v)	((Percent)(v))
-#define CHOOSE_PERCENT  AsPercent(101)
 
 
 typedef uintptr_t VA;
@@ -436,6 +435,7 @@ typedef uint64    BA;
 typedef uint32    BPN;
 typedef uint32    PageNum;
 typedef unsigned  MemHandle;
+typedef unsigned int  IoHandle;
 typedef int32     World_ID;
 
 /* !! do not alter the definition of INVALID_WORLD_ID without ensuring
@@ -540,23 +540,26 @@ typedef void * UserVA;
  * for any region other than buserror.
  */
 #define PHYSMEM_MAX_PPN   ((PPN)0xffffffff)
-#define MAX_PPN           ((PPN)0x1fffffff) /* Maximal observable PPN value. */
+#define MAX_PPN           ((PPN)0x3fffffff) /* Maximal observable PPN value. */
 #define INVALID_PPN       ((PPN)0xffffffff)
-#define APIC_DISABLED_PPN ((PPN)0xfffffffe)
+#define APIC_INVALID_PPN  ((PPN)0xfffffffe)
 
-#define INVALID_BPN       ((BPN)0x1fffffff)
+#define INVALID_BPN       ((BPN)0x3fffffff)
 
 #define RESERVED_MPN      ((MPN) 0)
 #define INVALID_MPN       ((MPN)-1)
 #define MEMREF_MPN        ((MPN)-2)
 #define RELEASED_MPN      ((MPN)-3)
-#define MAX_MPN           ((MPN)0x7fffffff)  /* 43 bits of address space. */
+
+/* 0xfffffffc to account for special MPNs defined above. */
+#define MAX_MPN           ((MPN)0xfffffffc)  /* 44 bits of address space. */
 
 #define INVALID_LPN       ((LPN)-1)
 #define INVALID_VPN       ((VPN)-1)
 #define INVALID_LPN64     ((LPN64)-1)
 #define INVALID_PAGENUM   ((PageNum)-1)
 
+#define INVALID_MPN64     ((MPN64)-1)
 
 /*
  * Format modifier for printing VA, LA, and VPN.
@@ -665,11 +668,24 @@ typedef void * UserVA;
  * that gcc will not do inlining.
  */
 
-#if defined(__GNUC__) && defined(VMM)
+#if defined(__GNUC__) && (defined(VMM) || defined (VMKERNEL) || defined (VMKBOOT))
 #define ABSOLUTELY_NOINLINE __attribute__((__noinline__))
 #endif
 
 /*
+ * Used when a function has no effects except the return value and the
+ * return value depends only on the parameters and/or global variables
+ * Such a function can be subject to common subexpression elimination
+ * and loop optimization just as an arithmetic operator would be. 
+ */
+
+#if defined(__GNUC__) && (defined(VMM) || defined (VMKERNEL))
+#define SIDE_EFFECT_FREE __attribute__((__pure__))
+#else
+#define SIDE_EFFECT_FREE
+#endif
+
+/*
  * Attributes placed on function declarations to tell the compiler
  * that the function never returns.
  */
@@ -683,6 +699,21 @@ typedef void * UserVA;
 #endif
 
 /*
+ * Static profiling hints for functions.
+ *    A function can be either hot, cold, or neither.
+ *    It is an error to specify both hot and cold for the same function.
+ *    Note that there is no annotation for "neither."
+ */
+
+#if defined __GNUC__ && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 3))
+#define HOT __attribute__((hot))
+#define COLD __attribute__((cold))
+#else
+#define HOT
+#define COLD
+#endif
+
+/*
  * Branch prediction hints:
  *     LIKELY(exp)   - Expression exp is likely TRUE.
  *     UNLIKELY(exp) - Expression exp is likely FALSE.
@@ -745,28 +776,23 @@ typedef void * UserVA;
 # endif
 #endif
 
+#ifndef UNUSED_TYPE
+// XXX _Pragma would better but doesn't always work right now.
+#  define UNUSED_TYPE(_parm) UNUSED_PARAM(_parm)
+#endif
+
+#ifndef UNUSED_VARIABLE
+// XXX is there a better way?
+#  define UNUSED_VARIABLE(_var) (void)_var
+#endif
+
 /*
- * REGPARM defaults to REGPARM3; i.e., a request that gcc
- * put the first three arguments in registers.  (It is fine
- * if the function has fewer than three arguments.)  Gcc only.
- * Syntactically, put REGPARM where you'd put INLINE or NORETURN.
- *
- * Note that 64-bit code already puts the first six arguments in
- * registers, so these attributes are only useful for 32-bit code.
+ * gcc can warn us if we're ignoring returns
  */
-
 #if defined(__GNUC__)
-# define REGPARM0 __attribute__((regparm(0)))
-# define REGPARM1 __attribute__((regparm(1)))
-# define REGPARM2 __attribute__((regparm(2)))
-# define REGPARM3 __attribute__((regparm(3)))
-# define REGPARM REGPARM3
+# define MUST_CHECK_RETURN __attribute__((warn_unused_result))
 #else
-# define REGPARM0
-# define REGPARM1
-# define REGPARM2
-# define REGPARM3
-# define REGPARM
+# define MUST_CHECK_RETURN
 #endif
 
 /*
@@ -815,7 +841,7 @@ typedef void * UserVA;
 #   endif
 
 #else
-#   ifndef _SIZE_T
+#   if !defined(_SIZE_T) && !defined(_SIZE_T_DEFINED)
 #      ifdef VM_I386
 #         define _SIZE_T
 #         ifdef VM_X86_64
@@ -831,7 +857,8 @@ typedef void * UserVA;
 
 #   if !defined(FROBOS) && !defined(_SSIZE_T) && !defined(_SSIZE_T_) && \
        !defined(ssize_t) && !defined(__ssize_t_defined) && \
-       !defined(_SSIZE_T_DECLARED) && !defined(_SSIZE_T_DEFINED_)
+       !defined(_SSIZE_T_DECLARED) && !defined(_SSIZE_T_DEFINED) && \
+       !defined(_SSIZE_T_DEFINED_)
 #      ifdef VM_I386
 #         define _SSIZE_T
 #         define __ssize_t_defined
